
(lap '(   % some DOS calls via interrupt
      (*entry uunixputc expr 1)
      (*alloc 0)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 5 (reg edx))
      (jmp "psll_call")
 nowin
      (mov (reg 1) (reg edx) )
      (mov 2 (reg ah))
      (mov 0 (reg al))
      (int 16#21)
      (*exit 0)))
  
(de unixputc (ch)
   (if (eq ch 10) %line feed
	(progn (uunixputc 13)
	       (uunixputc 10))
    (uunixputc ch)))
 
(de unixputs (str)
   (prog (i len)
	(setq i 0)
	(while (not (eq (byte str i) 0))
	  (unixputc (byte str i))
	  (setq i (wplus2 i 1))))))

(de unixputn (num)
   (prog (ziff ind)
       (setq ind -28)
     aa
       (setq ziff (wand (wshift num ind) 15))
       (if (wlessp ziff 10) (setq ziff (wplus2 ziff (inf '!0)))
	    (setq ziff (wplus2 ziff (wdifference (inf 'A) 10))))
       (uunixputc ziff)
       (setq ind (wplus2 4 ind))
       (when (wlessp ind 1) (go aa))
     (return nil)))

(de unixputdec (num)
   (prog (ziff ind)
       (when (eq num 0) (return nil))
       (setq ziff (wremainder num 10))
       (setq ziff (wplus2 ziff (inf '!0)))
       (unixputdec (wquotient num 10))
       (uunixputc ziff)
     (return nil)))

% file primitives

(de unixopen (name mode)
     (cond ((eq (byte mode 0) (inf '!w)) (ufcreate name 1))
	   (t (ufopen name 0))))

(lap '((*entry ufopen expr 2)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 6 (reg edx))
      (jmp "psll_call") 
   nowin
       (mov (reg 1) (reg edx))
       (mov (reg 2) (reg eax))
       (mov 16#3d (reg ah))
       (int 16#21)
       (jc  operror)
       (*exit 0)
     operror
       (*move 2 (reg 1))
       (*exit 0)))

(lap '((*entry ufcreate expr 2)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 7 (reg edx))
      (jmp "psll_call") 
   nowin
       (mov (reg 1) (reg edx))
       (*move 0 (reg ecx))  % no special attributes
       (mov 16#3c (reg ah))
       (int 16#21)
       (jc  operror)
       (*exit 0)
     operror
       (*move 2 (reg 1))
       (*exit 0)))

(lap '((*entry fclose expr 1)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 8 (reg edx))
      (jmp "psll_call") 
   nowin
       (mov (reg 1) (reg ebx))
       (mov 16#3e (reg ah))
       (int 16#21)
       (*exit 0)))

(lap '((*entry fseek expr 3)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 22 (reg edx))
      (jmp "psll_call")
   nowin
       (*move (reg 2)(reg 4))
       (*move (reg 1)(reg 2))   % file handle
       (mov (reg cl)(reg al))    % mode
       (mov 16#42 (reg ah))
       (*move (reg 4)(reg 3))
       (*wshift (reg 3) -16)
       (*wand (reg 4) 16#ffff)
       (int 16#21)
       (jc  error)
       (*wand (reg 1) 16#ffff)
       (*wshift (reg 4) 16)
       (*wor (reg 1)(reg 4))
       (*exit 0)
   error
       (*move (wconst -1) (reg 1))
       (*exit 0)))

(de getw (fp)
       (fread ONEWORDBUFFER 0 1 fp)
       (getmem ONEWORDBUFFER))

(lap '((*entry fread expr 4)
       (*wshift (reg 3) 2)
      (*move ($fluid **windows)(reg 5))
      (cmp 0 (reg 5))
      (je nowin)
      (*move (reg 1)(reg 2))
      (*move (reg 4)(reg 1))
      (*move 9 (reg edx))
      (jmp "psll_call") 
   nowin
       (mov (reg 4) (reg t1))
       (mov (reg 1) (reg edx))
       (mov (reg 3) (reg ecx))
       (mov (reg t1) (reg ebx))
       (mov 16#3f (reg ah))
       (int 16#21)
       (*exit 0)))

(de putw (w fp)
       (putmem ONEWORDBUFFER w)
       (fwrite ONEWORDBUFFER 4 1 fp))

(lap '((*entry fwrite expr 4)
       (*move ($fluid **windows)(reg 5))
       (cmp 0 (reg 5))
       (je nowin)
       (*move (reg 2)(reg 3)) 
       (*move (reg 1)(reg 2))
       (*move (reg 4)(reg 1))
       (*move 10 (reg edx))
       (jmp "psll_call") 
   nowin
       (mov (reg 4) (reg t1))
       (mov (reg 1) (reg edx))
       (mov (reg 2) (reg ecx))
%%%%%% (imul (reg 2) (reg 3))
       (mov (reg t1) (reg ebx))
       (mov 16#40 (reg ah))
       (int 16#21)
       (*exit 0)))

(lap '((*entry fflush expr 0)
       (*exit 0)))

(lap '((*entry fgets expr 3)
       (*alloc 2)
       (*move (reg 2) (frame 1))   % length 
       (*move (reg 1) (frame 2))   % buffer
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*move (reg 3)(reg 4))
       (*move (reg 2)(reg 3))
       (*wplus2 (reg 3) -4)
       (*move (reg 1)(reg 2))
       (*move (reg 4)(reg 1))
       (*move 16 (reg edx))
       (call "psll_call") 
       (*move (frame 2) (reg edx))
       (*wplus2 (reg edx)(reg eax))
       (*move 0 (reg t1))
       (*move (reg t1)(displacement (reg edx) 0))
       (*move (frame 2)(reg edx))
       (*jump common)
   nowin
       (*move (reg 1) (reg edx))
       (*move (reg 3) (reg t1))
       (*move (reg 2) (reg ecx))
       (*wplus2 (reg ecx) -4)
       (*move (reg t1) (reg ebx))
       (*move 16#3f00 (reg eax))
       (int 16#21)
   common
       (*move 10 (reg t1))  % a line feed
       (*wplus2 (reg edx) (reg eax))
       (*move (frame 1) (reg 2))
       (*wplus2 (reg 2) -4)
       (*jumpeq (label nolf) (reg 2) (reg eax))
       (*move (reg t1) (displacement (reg edx) 0) )
       (*wplus2 (reg edx) 1)
      nolf
       (*move 0 (reg t1))
       (*move (reg t1) (displacement (reg edx) 0) )
       (*exit 2)))

(lap '((*entry enlarge expr 1)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*exit 0) 
   nowin
       (*move (reg 1) (reg ebx))
       (mov (reg cs) (reg ax))
       (mov (reg ax) (reg es))
       (*move 0 (reg al))
%      (*move 16#4a (reg ah))
       (*move 16#48  (reg ah))
       (int 16#21)
       (*exit 0)))

(de external_time (x) x) 

(lap '((*entry external_exit expr 0)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*move 0 (reg eax))
       (jmp "psll_main") 
   nowin
       (*move 0 (reg eax))
       (int 16#21)
       (*exit 0)))

(de ieee_handler () nil)

(lap '((*entry getdat expr 1)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*move 12 (reg edx))
       (jmp "psll_call") 
   nowin
       (*move (reg 1) (reg ebx))
       (*move 16#2a (reg ah))
       (int 16#21)
       (*move (reg ecx) (displacement (reg ebx) 0))
       (*move (reg edx) (displacement (reg ebx) 4))
       (*exit 0)))

(de date ()
    (bldmsg " %w %w-%w-%w " (getv '["Sun" "Mon" "Tue" "Wed" "Thu" "Fri" "Sat"]
				(wand (getdat onewordbuffer) 255))
			    (wand (wgetv  onewordbuffer 1) 255)
			    (wand (wshift (wgetv  onewordbuffer 1) -8) 255)
			    (wand 16#ffff (wgetv  onewordbuffer 0))))))

(lap '((*entry gettime expr 1) 
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*move 19 (reg edx))
       (jmp "psll_call") 
   nowin
       (*move (reg 1) (reg ebx)) 
       (push (reg ebx))
       (*move 16#2c (reg ah)) 
       (int 16#21) 
       (pop (reg ebx))
       (*move (reg ecx) (displacement (reg ebx) 0)) 
       (*move (reg edx) (displacement (reg ebx) 4)) 
       (*exit 0))) 
 
(fluid '(timc-initvalue*))

(de external_timc (abuff)  % time in 1/100 sec
   (gettime onewordbuffer)
   (putmem abuff
   (wdifference
   (wplus2
    (wtimes2
     (wplus2
      (wtimes2
       (wplus2 (wtimes2 (wand 255(wshift (wgetv  onewordbuffer 0) -8)) 60)
	       (wand (wgetv  onewordbuffer 0) 255)) 60) 
      (wand 255 (wshift (wgetv  onewordbuffer 1) -8))) 100) 
    (wand (wgetv onewordbuffer 1) 255))
    timc-initvalue*)))

(lap '((*entry sig_set expr 2)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*move 14 (reg edx))
       (jmp "psll_call") 
   nowin
       (*move (reg 2) (reg edx))
       (*move 16#25 (reg ah))
       (int 16#21)
       (*exit 0)))

(lap '((*entry unixcd expr 2) % second argument: drive number
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*move 15 (reg edx))
      (jmp "psll_call") 
   nowin
      (cmp 0 (reg ebx))
      (je nodrive)     
      (push (reg 1))
      (*move (reg ebx)(reg edx))
      (dec (reg edx))
      (*move 16#0e (reg ah))
      (int 16#21)
      (pop (reg 1))
   nodrive
      (*move (reg 1) (reg edx))
      (*move 16#3b (reg ah))
      (int 16#21)
      (*exit 0)))

(lap '((*entry unixmkdir expr 1)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (*exit 0)
    nowin
      (*move (reg 1) (reg edx))
      (*move 16#39 (reg ah))
      (int 16#21)
      (*exit 0)))
 
(lap '((*entry unixrmdir expr 1)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*exit 0)
   nowin
      (*move (reg 1) (reg edx))
      (*move 16#3a (reg ah))
      (int 16#21)
      (*exit 0)))
 
(lap '((*entry unixdelete expr 1)
      (*move ($fluid **windows)(reg edx))
      (cmp 0 (reg edx))
      (je nowin)
      (*exit 0)
   nowin
      (*move (reg 1) (reg edx))
      (*move 16#41 (reg ah))
      (int 16#21)
      (*exit 0)))

% character io: interrupts 1 2 and b

(lap '((*entry int_1 expr 1)
       (*move 0 (reg eax))
       (mov 1 (reg ah))
       (int 16#21)
       (*exit 0)))

(lap '((*entry int_2 expr 1) 
       (*move (reg 1) (reg edx))
       (*move 0 (reg eax)) 
       (mov 2 (reg ah)) 
       (int 16#21)
       (*exit 0)))

(lap '((*entry int_7 expr 1)
       (*move 0 (reg eax))
       (mov 7 (reg ah))
       (int 16#21)
       (*exit 0)))

(lap '((*entry int_8 expr 1)
       (*move 0 (reg eax))
       (mov 8 (reg ah))
       (int 16#21)
       (*exit 0)))
 
(lap '((*entry int_b expr 1) 
       (*move 0 (reg eax)) 
       (mov 16#b (reg ah)) 
       (int 16#21)
       (*exit 0)))

(lap '((*entry psll-call expr 4)
       (*move ($fluid **windows)(reg 5))
       (cmp 0 (reg 5))
       (je nowin)
       (jmp "psll_call") 
   nowin
       (*exit 0)))
	
(lap '((*entry psll-main expr 1)
       (*move ($fluid **windows)(reg edx))
       (cmp 0 (reg edx))
       (je nowin)
       (jmp "psll_main") 
   nowin
       (*exit 0)))
	

